#!/bin/bash

# Register Your Trial Version Of SLES 12 SP2 And Install SLES 12 SP2 SDK

sudo SUSEConnect --status-text
sudo SUSEConnect -r $1 -e $2
sudo SUSEConnect -p sle-sdk/12.2/x86_64

# Create TensorFlow Model Server Administrator Account 
# And Add It To Sudoers List With No-Password Option

echo "Creating TensorFlow Model Server (TMS) Administrator Account..."

sudo bash -c 'sudo useradd -m -d /home/tmsadm -c "TensorFlow Administrator" tmsadm'
sudo bash -c 'sudo passwd tmsadm'
sudo bash -c 'echo "tmsadm ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers'

# Copy clients_linux_x86_64.tgz archive to TMS Administrator Home Directory

sudo bash -c 'sudo cp clients_linux_x86_64.tgz /home/tmsadm/'

# Extract Files From SAP-HANA Clients And EML Library Archieves

sudo su -l tmsadm bash -c "sudo tar -xvf ~/clients_linux_x86_64.tgz"
sudo su -l tmsadm bash -c "sudo tar -xvf ~/hdb_client_linux_x86_64.tgz"
sudo su -l hxeadm bash -c "sudo tar -xvf ~/eml.tgz -C ~"

# Install SAP-HANA Clients For Linux

sudo su -l tmsadm bash -c "~/HDB_CLIENT_LINUX_X86_64/hdbinst"

# Set SAP-HANA HDB Client Default Path

sudo su -l tmsadm bash -c 'echo "export PATH=\$PATH:/home/tmsadm/sap/hdbclient" >> ~/.profile'
sudo su -l tmsadm bash -c 'source .profile'

# Run SAP-HANA System Optimizer

sudo su -l hxeadm bash -c 'cd /usr/sap/HXE/home/bin && hxe_gc.sh'

sudo su -l hxeadm bash -c 'sudo chown -R hxeadm ~/HANA_EXPRESS_20'

# Install SAP-HANA EML Library

sudo su -l hxeadm bash -c "~/HANA_EXPRESS_20/install_eml.sh"

# Download Python's PIP Installation Script

sudo su -l tmsadm bash -c "curl https://bootstrap.pypa.io/get-pip.py -o get-pip.py"

# Install Python's PIP

sudo su -l tmsadm bash -c "sudo python get-pip.py --trusted-host pypi.python.org"

# Set Python's PIP Default Path

sudo su -l tmsadm bash -c 'cd ~ && echo "export PATH=\$PATH:/home/tmsadm/.local/bin" >> ~/.profile'

sudo su -l tmsadm bash -c "source .profile"

# Install Python's Virtual Environment

sudo su -l tmsadm bash -c "pip install --user virtualenv"

# Run Python's Virtual Environment

sudo su -l tmsadm bash -c "virtualenv --python=python2.7 --system-site-packages ~/tms"

sudo su -l tmsadm bash -c "source ~/tms/bin/activate"

# Install SAP-HANA HDB Client CLI From Archieve

sudo su -l tmsadm bash -c "sudo pip install --user /home/tmsadm/sap/hdbclient/hdbcli-2.4.126.tar.gz"

# Install TensorFlow And TensorFlow Serving APIs For Python

sudo su -l tmsadm bash -c "sudo pip install 'tensorflow==1.8'"

sudo su -l tmsadm bash -c "sudo pip install 'tensorflow-serving-api==1.12.0'"

# Create '/home/tmsadm/export' Directory And TensorFlow Models Configuration Script

sudo su -l tmsadm bash -c "mkdir -p ~/export"

sudo su -l tmsadm bash -c 'echo "model_config_list: {}" >> ~/export/models.config'